# How to contribute

CSLA .NET is developed and maintained by a [global development team](https://github.com/MarimerLLC/csla/graphs/contributors) composed of volunteers. We welcome your help!

## Getting started

* Review the [Code of Conduct](https://github.com/MarimerLLC/csla/blob/master/CODE_OF_CONDUCT.md)
* Make sure you have a [GitHub account](https://github.com/signup/free)
* Download, print, sign, scan, and return the [contributor agreement document](https://github.com/MarimerLLC/csla/blob/master/Support/Contributions/CSLA%20Contributor%20Agreement.pdf).
* Review and follow the [Coding standards](https://github.com/MarimerLLC/csla/blob/master/docs/dev/Coding-standards.md) we use to maintain consistent code in the framework
* Engage
  * Bring up your idea in a [Discussion](https://github.com/MarimerLLC/csla/discussions) and talk it through with the community
  * Or bring up your idea in the [Discord server](https://discord.gg/9ahKjb7ccf) and talk it through there
  * Submit an [Issue](https://github.com/MarimerLLC/csla/issues) for your suggestion, assuming one does not already exist
* For beginners we suggest
  * This online course on [contributing to OSS projects on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github)
  * This excellent blog post on [Being a good open source citizen](https://hackernoon.com/being-a-good-open-source-citizen-9060d0ab9732#.4owk5884d)
  * Information on the [CSLA git flow](https://github.com/MarimerLLC/csla/blob/master/docs/dev/csla-github-flow.md) used on this project

## Making Changes

* We have a doc with step-by-step instructions on [how to use git and GitHub to contribute](https://github.com/MarimerLLC/csla/blob/master/docs/dev/csla-github-flow.md) to CSLA .NET
* Follow the [CSLA git flow](https://github.com/MarimerLLC/csla/blob/master/docs/dev/csla-github-flow.md) used on this project
* Create a topic/feature/issue branch from where you want to base your work
* Make sure you have added the necessary tests for your changes

## Submitting Changes

* Print, sign, and email the [contributor agreement](https://github.com/MarimerLLC/csla/blob/master/Support/Contributions/CSLA%20Contributor%20Agreement.pdf?raw=true) document to Marimer LLC (rocky at lhotka dot net)
  * We will not accept large changes without a signed contributor agreement, but we may accept small edits to the existing codebase
  * By submitting a change, large or small, you grant ownership of the code and related IP to Marimer LLC, and you certify that you have the right to transfer such ownership
* Push your changes to a topic branch in your fork of the repository.
* Submit a pull request (PR) to the repository in the Marimer LLC organization.
  * Make sure the issue number (e.g. #999) is in the _description_ (not title) of the PR so GitHub can automatically link the PR to the issue
  * Submitting a PR will trigger a CI build; make sure the CI build passes with your changes and new unit tests

## Additional Resources

* [General GitHub documentation](http://help.github.com/)
* [GitHub pull request documentation](http://help.github.com/send-pull-requests/)
